local function execDebug()
  local input = io.input()
  local result = { pcall(input.read, input, "*l") }
  if not result[1] then
    return false, result[2]
  end

  local func = load("return " .. result[2])
  if type(func) ~= "function" then
    return false, func
  end

  return pcall(func)
end

local function debugREPL(onResult)
  local result, retval
  repeat
    result, retval = execDebug()
    if result and type(onResult) == "function" then
      onResult(retval)
    end
  until not result
  return retval
end

return { debugREPL = debugREPL, execDebug = execDebug }